---
title: Update a permanent RUM retention filter
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Rum Retention Filters
---

# Update a permanent RUM retention filter{% #update-a-permanent-rum-retention-filter %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                                                       |
| ----------------- | ------------------------------------------------------------------------------------------------------------------ |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id} |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id} |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id}      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id}      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id}  |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id}     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id} |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/rum/applications/{app_id}/retention_filters/permanent/{permanent_rf_id} |

### Overview

Update the cross-product sampling configuration of a permanent RUM retention filter for a RUM application. Only fields marked as editable in the `editability` block of the filter can be updated. Updating a non-editable field returns a `400` response.

### Arguments

#### Path Parameters

| Name                              | Type   | Description                                           |
| --------------------------------- | ------ | ----------------------------------------------------- |
| app_id [*required*]          | string | RUM application ID.                                   |
| permanent_rf_id [*required*] | string | The identifier of the permanent RUM retention filter. |

### Request

#### Body Data (required)

New configuration of the permanent RUM retention filter.

{% tab title="Model" %}

| Parent field           | Field                        | Type    | Description                                                                                                                                 |
| ---------------------- | ---------------------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------- |
|                        | data [*required*]       | object  | The new permanent RUM retention filter configuration to update.                                                                             |
| data                   | attributes [*required*] | object  | The configuration to update on a permanent RUM retention filter.                                                                            |
| attributes             | cross_product_sampling       | object  | The configuration for cross-product retention filters. All fields are optional for partial updates.                                         |
| cross_product_sampling | trace_enabled                | boolean | Whether the cross-product retention filter for APM traces is enabled.                                                                       |
| cross_product_sampling | trace_sample_rate            | double  | The sample rate for the APM cross-product retention filter, between 0 and 100.                                                              |
| data                   | id [*required*]         | enum    | The identifier of a permanent RUM retention filter. Allowed enum values: `rum_apm_flat_sampling,synthetics_sessions,forced_replay_sessions` |
| data                   | type [*required*]       | enum    | The type of the resource. The value should always be `permanent_retention_filters`. Allowed enum values: `permanent_retention_filters`      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "cross_product_sampling": {
        "trace_enabled": true,
        "trace_sample_rate": 25
      }
    },
    "id": "synthetics_sessions",
    "type": "permanent_retention_filters"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
Updated
{% tab title="Model" %}
A permanent RUM retention filter object.

| Parent field           | Field                  | Type    | Description                                                                                                                                 |
| ---------------------- | ---------------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------- |
|                        | data                   | object  | A permanent RUM retention filter.                                                                                                           |
| data                   | attributes             | object  | The attributes of a permanent RUM retention filter.                                                                                         |
| attributes             | cross_product_sampling | object  | The configuration for cross-product retention filters.                                                                                      |
| cross_product_sampling | trace_enabled          | boolean | Whether the cross-product retention filter for APM traces is enabled.                                                                       |
| cross_product_sampling | trace_sample_rate      | double  | The sample rate for the APM cross-product retention filter, between 0 and 100.                                                              |
| attributes             | description            | string  | A description of what the filter retains.                                                                                                   |
| attributes             | editability            | object  | Indicates which cross-product fields of a permanent RUM retention filter can be updated.                                                    |
| editability            | trace_editable         | boolean | Whether the APM trace cross-product configuration of the filter can be updated.                                                             |
| attributes             | name                   | string  | The display name of the permanent retention filter.                                                                                         |
| data                   | id                     | enum    | The identifier of a permanent RUM retention filter. Allowed enum values: `rum_apm_flat_sampling,synthetics_sessions,forced_replay_sessions` |
| data                   | type                   | enum    | The type of the resource. The value should always be `permanent_retention_filters`. Allowed enum values: `permanent_retention_filters`      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "cross_product_sampling": {
        "trace_enabled": true,
        "trace_sample_rate": 25
      },
      "description": "All sessions generated by Synthetics are retained at 100%.",
      "editability": {
        "trace_editable": true
      },
      "name": "Synthetics Sessions"
    },
    "id": "synthetics_sessions",
    "type": "permanent_retention_filters"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export app_id="CHANGE_ME" export permanent_rf_id="synthetics_sessions" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/rum/applications/${app_id}/retention_filters/permanent/${permanent_rf_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "cross_product_sampling": {
        "trace_enabled": true,
        "trace_sample_rate": 50
      }
    },
    "id": "synthetics_sessions",
    "type": "permanent_retention_filters"
  }
}
EOF 
                
{% /tab %}
